package com.ruoyi.tc.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.tc.entity.AssetLc;
import com.ruoyi.tc.entity.request.AssetLcRequest;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;
import java.util.List;

/**
 * 任务流程(AssetLc)表数据库访问层
 *
 * @author makejava
 * @since 2024-11-18 14:46:40
 */
public interface AssetLcMapper {


    /**
     * 页条件查询
     *

     * @param pageRequest  查询条件
     * @return 填报任务
     */
    List<AssetLc> queryByPage( @Param("req") AssetLcRequest pageRequest);


    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    AssetLc queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param assetLc 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<AssetLc> queryAllByLimit(AssetLc assetLc, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param assetLc 查询条件
     * @return 总行数
     */
    long count(AssetLc assetLc);

    /**
     * 新增数据
     *
     * @param assetLc 实例对象
     * @return 影响行数
     */
    int insert(AssetLc assetLc);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<AssetLc> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<AssetLc> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<AssetLc> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<AssetLc> entities);

    /**
     * 修改数据
     *
     * @param assetLc 实例对象
     * @return 影响行数
     */
    int update(AssetLc assetLc);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

}

