package com.ruoyi.tc.service.impl;

import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.bean.BeanUtils;
import com.ruoyi.tc.entity.AssetBasicNetwork;
import com.ruoyi.tc.entity.AssetBusinessForm;
import com.ruoyi.tc.entity.AssetCurrent;
import com.ruoyi.tc.entity.AssetLc;
import com.ruoyi.tc.entity.AssetSupplyChain;
import com.ruoyi.tc.entity.AssetTask;
import com.ruoyi.tc.entity.UnitOtherConcat;
import com.ruoyi.tc.entity.po.AssetBasicNetworkCpPo;
import com.ruoyi.tc.entity.po.AssetBusinessFormCpPo;
import com.ruoyi.tc.entity.po.AssetCurrentCpPo;
import com.ruoyi.tc.entity.po.AssetSupplyChainCpPo;
import com.ruoyi.tc.entity.po.UnitOtherConcatCpPo;
import com.ruoyi.tc.entity.request.Acomma;
import com.ruoyi.tc.entity.request.AssestTaskXqRequest;
import com.ruoyi.tc.entity.request.AssetCurrentShRequest;
import com.ruoyi.tc.entity.request.AssetTaskPageRequest;
import com.ruoyi.tc.entity.request.AssetdwHcRequest;
import com.ruoyi.tc.entity.response.AssestTaskXqresponse;
import com.ruoyi.tc.entity.response.AssetTaskResponse;
import com.ruoyi.tc.entity.response.AssetTaskStatusResponse;
import com.ruoyi.tc.entity.response.AssetdwHcResponse;
import com.ruoyi.tc.mapper.AssetTaskMapper;
import com.ruoyi.tc.service.AssetBasicNetworkCpService;
import com.ruoyi.tc.service.AssetBasicNetworkService;
import com.ruoyi.tc.service.AssetBusinessFormCpService;
import com.ruoyi.tc.service.AssetBusinessFormService;
import com.ruoyi.tc.service.AssetCurrentCpService;
import com.ruoyi.tc.service.AssetCurrentService;
import com.ruoyi.tc.service.AssetLcService;
import com.ruoyi.tc.service.AssetSupplyChainCpService;
import com.ruoyi.tc.service.AssetSupplyChainService;
import com.ruoyi.tc.service.AssetTaskService;
import com.ruoyi.tc.service.UnitOtherConcatCpService;
import com.ruoyi.tc.service.UnitOtherConcatService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 任务主表(AssetTask)表服务实现类
 *
 * @author makejava
 * @since 2024-11-18 13:23:09
 */
@Service("assetTaskService")
public class AssetTaskServiceImpl extends ServiceImpl<AssetTaskMapper, AssetTask> implements AssetTaskService {
    @Resource
    private AssetTaskMapper assetTaskDao;

    @Resource
    private AssetCurrentCpService assetCurrentCpService;

    @Resource
    private AssetBusinessFormCpService assetBusinessFormCpService;

    @Resource
    private AssetSupplyChainCpService assetSupplyChainCpService;


    @Resource
    private AssetBasicNetworkCpService assetBasicNetworkCpService;


    @Resource
    private UnitOtherConcatCpService unitOtherConcatCpService;

    @Resource
    private AssetLcService assetLcService;

    @Resource
    private AssetCurrentService assetCurrentService;


    @Resource
    private AssetBusinessFormService assetBusinessFormService;

    @Resource
    private AssetBasicNetworkService assetBasicNetworkService;


    @Resource
    private AssetSupplyChainService assetSupplyChainService;

    @Resource
    private UnitOtherConcatService unitOtherConcatService;

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public AssetTaskResponse queryById(Integer id) {
        return assetTaskDao.queryById(id);
    }

    /**
     * 分页查询
     *
     * @param assetTask   筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @Override
    public Page<AssetTask> queryByPage(Page<AssetTask> assetTask, AssetTaskPageRequest pageRequest) {
        return assetTaskDao.queryByPage(assetTask, pageRequest);
    }

    /**
     * 新增数据
     *
     * @param assetTask 实例对象
     */
    @Override
    public void insert(AssetTask assetTask) {
        //任务新增
        assetTaskDao.insert(assetTask);
        int id = assetTask.getId();
        //新增流程节点
        AssetLc assetLc = new AssetLc();
        assetLc.setTaskId(id);
        assetLc.setXfTime(LocalDateTime.now());
        assetLc.setAssetName("管理员任务下发");
        assetLcService.insert(assetLc);
        String[] parts = assetTask.getDwmc().split(",");
        for (String part : parts) {
            //根据单位名称查询资产
            List<AssetCurrentCpPo> list = assetTaskDao.findByDwmcAssetCurrent(part);
            for (AssetCurrentCpPo assetCurrentResponse : list) {
                assetCurrentResponse.setTaskId(id);
            }
            assetCurrentCpService.saveBatch(list);
            List<AssetBusinessFormCpPo> assetBusinessFormCpResponseList = new ArrayList<>();
            for (AssetCurrentCpPo assetCurrentResponse : list) {
                //新增新监管业务形态
                //根据资产id查询新监管业务形态主表id
                List<AssetBusinessFormCpPo> bussList = assetBusinessFormCpService.findByassetId(assetCurrentResponse.getId());
                if (bussList != null) {
                    for (AssetBusinessFormCpPo assetBusinessFormCpResponse : bussList) {
                        if (assetCurrentResponse.getXjgywxt() != null) {
                            assetCurrentResponse.getXjgywxt().setAssetId(assetBusinessFormCpResponse.getAssetId());
                            assetCurrentResponse.getXjgywxt().setTaskId(id);
                            assetBusinessFormCpResponseList.add(assetCurrentResponse.getXjgywxt());
                        }
                    }
                    assetBusinessFormCpService.saveBatch(assetBusinessFormCpResponseList);
                }
                //根据资产id查询供应链主表id-
                List<AssetSupplyChainCpPo> supplyChainList = assetSupplyChainCpService.findByassetId(assetCurrentResponse.getId());
                if (supplyChainList != null) {
                    for (AssetSupplyChainCpPo items : supplyChainList) {
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setSupplyId(items.getSupplyId());
                        items.setTaskId(id);
                        //新增供应链
                    }
                    assetSupplyChainCpService.saveBatch(supplyChainList);
                }
                List<AssetBasicNetworkCpPo> BasicNetworkCpList = assetBasicNetworkCpService.findByassetId(assetCurrentResponse.getId());
                if (BasicNetworkCpList != null) {
                    for (AssetBasicNetworkCpPo items : BasicNetworkCpList) {
                        //根据资产id查询基础网络主表id
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setNetworkId(items.getNetworkId());
                        items.setTaskId(id);
                        //新增基础网络
                    }
                    assetBasicNetworkCpService.saveBatch(BasicNetworkCpList);
                }
                List<UnitOtherConcatCpPo> unitOtherConcatList = unitOtherConcatCpService.findByassetId(assetCurrentResponse.getId());
                if (unitOtherConcatList != null) {
                    for (UnitOtherConcatCpPo items : unitOtherConcatList) {
                        //根据资产id查询其他联系人主表id
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setConcatId(items.getConcatId());
                        items.setTaskId(id);
                        //新增其他联系人
                    }
                    unitOtherConcatCpService.saveBatch(unitOtherConcatList);
                }
            }
        }

    }

    /**
     * 修改数据
     *
     * @param assetTask 实例对象
     * @return 实例对象
     */
    @Override
    public int update(AssetTask assetTask) {
        return this.assetTaskDao.update(assetTask);

    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer id) {
        return this.assetTaskDao.deleteById(id) > 0;
    }

    @Override
    public AssetCurrentCpPo taskSh(int taskId, int assetId) {
        AssetCurrentCpPo byId = assetTaskDao.findBytaskIdandAssestId(taskId, assetId);
        byId.setGylxxList(assetSupplyChainCpService.lambdaQuery().eq(AssetSupplyChainCpPo::getAssetId, assetId).eq(AssetSupplyChainCpPo::getDelFlag, "0").eq(AssetSupplyChainCpPo::getTaskId, taskId).list());
        byId.setJcwlList(assetBasicNetworkCpService.lambdaQuery().eq(AssetBasicNetworkCpPo::getAssetId, assetId).eq(AssetBasicNetworkCpPo::getDelFlag, "0").eq(AssetBasicNetworkCpPo::getTaskId, taskId).list());
        byId.setXjgywxt(assetBusinessFormCpService.lambdaQuery().eq(AssetBusinessFormCpPo::getAssetId, assetId).eq(AssetBusinessFormCpPo::getDelFlag, "0").eq(AssetBusinessFormCpPo::getTaskId, taskId).one());
        byId.setOtherConcat(unitOtherConcatCpService.lambdaQuery().eq(UnitOtherConcatCpPo::getAssetId, assetId).eq(UnitOtherConcatCpPo::getDelFlag, "0").eq(UnitOtherConcatCpPo::getTaskId, taskId).list());
        List<Acomma> a1 = new ArrayList<>();
        Arrays.asList(byId.getGlym().split(",")).forEach(x -> {
            Acomma acomma = new Acomma();
            acomma.setKey(x);
            a1.add(acomma);
        });
        byId.setGlymList(a1);
        List<Acomma> a2 = new ArrayList<>();
        Arrays.asList(byId.getGlIp().split(",")).forEach(x -> {
            Acomma acomma = new Acomma();
            acomma.setKey(x);
            a2.add(acomma);
        });
        byId.setGlIpList(a2);
        return byId;
    }

    @Override
    public Page<AssestTaskXqresponse> zcHc(Page<AssestTaskXqresponse> assetTask, AssestTaskXqRequest pageRequest) {
        assetTask.setOptimizeCountSql(false);
        Page<AssestTaskXqresponse> result = assetTaskDao.zcHc(assetTask, pageRequest);
        // 确保 records 不为 null
        if (result.getRecords() == null) {
            result.setRecords(new ArrayList<>()); // 设置为空数组
        }
        return result;
    }

    @Override
    public int sh(AssetCurrentShRequest req) {
        AssetLc assetLc = new AssetLc();
        int taskStatus = 0;
        if (req.getStatus() == 3) {
            assetLc.setTaskId(req.getTaskId());
            assetLc.setXfTime(LocalDateTime.now());
            assetLc.setAssetName("管理员审核通过"+req.getXtmc());
            assetLcService.insert(assetLc);
        } else if (req.getStatus() == 4) {
            assetLc.setTaskId(req.getTaskId());
            assetLc.setAssetName("管理员审核不通过"+req.getXtmc());
            assetLc.setXfTime(LocalDateTime.now());
            assetLcService.insert(assetLc);
        }
        int a = assetTaskDao.sh(req);
        //单位端资产审核，更新任务表状态
        //查询当前任务下的所有资产状态和完成时间
        List<AssetTaskStatusResponse> list = assetTaskDao.findByTaskId(req.getTaskId());
        // 检查状态
        boolean hasPendingApproval = list.stream().anyMatch(item -> item.getStatus() == 0 || item.getStatus() == 1);
        boolean allApproved = list.stream().allMatch(item -> item.getStatus() == 3);
        boolean hasExpired = list.stream().anyMatch(item -> item.getDeadstatus() == 6);
        boolean hasRejected = list.stream().anyMatch(item -> item.getStatus() == 4);
        boolean hased = list.stream().anyMatch(item -> item.getStatus() == 5);
        LocalDateTime finishTime = null;
        if (hasPendingApproval) {
            // 资产状态存在待审批，任务状态为进行中
            taskStatus = 1;
        } else if (allApproved && !hasPendingApproval && !hasRejected && !hasExpired) {
            // 资产状态全部为已通过中并且全部资产完成时间在任务期限之前
            taskStatus = 2;
            finishTime = LocalDateTime.now();
            taskSaveOrDelete(req);
        } else if (allApproved && !hasPendingApproval && !hasRejected && hasExpired) {
            // 资产状态全部为已通过，资产完成时间有超期的为超期完成
            taskStatus = 3;
            finishTime = LocalDateTime.now();
            taskSaveOrDelete(req);
        } else if (hasRejected) {
            // 审核不通过
            taskStatus = 1;
        } else if (hased && !hasRejected && !hasExpired) {
           //存在已报废并且其他都已完成 且未超期
            taskStatus = 2;
            finishTime = LocalDateTime.now();
            taskSaveOrDelete(req);
        }
        else if(hased && !hasRejected && hasExpired){
            //存在已报废并且其他都已完成 且未超期
            taskStatus = 3;
            finishTime = LocalDateTime.now();
            taskSaveOrDelete(req);
        } else if (hased  && !hasPendingApproval && !allApproved && ! hasExpired && !hasRejected) {
            taskStatus = 3;
        }
        //修改主表任务状态
        assetTaskDao.updateByTaskId(taskStatus, req.getTaskId(), finishTime);
        return a;
    }

    private void taskSaveOrDelete(AssetCurrentShRequest req) {
        // 根据taskid查询五张数据
        List<AssetCurrentCpPo> currentList = assetCurrentCpService.findByTaskId(req.getTaskId());
        List<Long> idList = currentList.stream()
                .map(AssetCurrentCpPo::getId)
                .collect(Collectors.toList());
        //删除原有数据
        if (CollectionUtil.isNotEmpty(idList)) {
            assetCurrentService.deleteIdList(idList);
        }

        //将子表数据复制到主表中
        List<AssetCurrent> currentNewList = currentList.stream()
                .map(cpPo -> {
                    AssetCurrent current = new AssetCurrent();
                    BeanUtils.copyProperties(cpPo, current); // 复制属性
                    return current; // 返回新对象
                })
                .collect(Collectors.toList()); // 收集到列表中
        assetCurrentService.saveBatch(currentNewList);
        //AssetBusinessFormCpPo
        List<AssetBusinessFormCpPo> bussinessList = assetBusinessFormCpService.findByTaskId(req.getTaskId());
        List<Long> bussinessidList = bussinessList.stream()
                .map(AssetBusinessFormCpPo::getAssetId)
                .collect(Collectors.toList());
        //删除原有数据
        if (CollectionUtil.isNotEmpty(bussinessidList)) {
            assetBusinessFormService.deleteIdList(bussinessidList);
        }

        //将子表数据复制到主表中
        List<AssetBusinessForm> bussinessNewList = bussinessList.stream()
                .map(cpPo -> {
                    AssetBusinessForm businessForm = new AssetBusinessForm();
                    BeanUtils.copyProperties(cpPo, businessForm); // 复制属性
                    return businessForm; // 返回新对象
                })
                .collect(Collectors.toList()); // 收集到列表中
        assetBusinessFormService.saveBatch(bussinessNewList);
        //AssetBasicNetworkCpPo
        List<AssetBasicNetworkCpPo> netWorkList = assetBasicNetworkCpService.findByTaskId(req.getTaskId());
        List<Long> netWorkidList = netWorkList.stream()
                .map(AssetBasicNetworkCpPo::getAssetId)
                .collect(Collectors.toList());
        //删除原有数据
        if (CollectionUtil.isNotEmpty(netWorkidList)) {
            assetBasicNetworkService.deleteIdList(netWorkidList);
        }

        //将子表数据复制到主表中
        List<AssetBasicNetwork> netWorkNewList = netWorkList.stream()
                .map(cpPo -> {
                    AssetBasicNetwork network = new AssetBasicNetwork();
                    BeanUtils.copyProperties(cpPo, network); // 复制属性
                    return network; // 返回新对象
                })
                .collect(Collectors.toList()); // 收集到列表中
        assetBasicNetworkService.saveBatch(netWorkNewList);
        //AssetSupplyChainCpPo
        List<AssetSupplyChainCpPo> SupplyChainList = assetSupplyChainCpService.findByTaskId(req.getTaskId());
        List<Long> SupplyChainidList = SupplyChainList.stream()
                .map(AssetSupplyChainCpPo::getAssetId)
                .collect(Collectors.toList());
        //删除原有数据
        if (CollectionUtil.isNotEmpty(SupplyChainidList)) {
            assetSupplyChainService.deleteIdList(SupplyChainidList);
        }

        List<AssetSupplyChain> SupplyChainNewList = SupplyChainList.stream()
                .map(cpPo -> {
                    AssetSupplyChain supplyChain = new AssetSupplyChain();
                    supplyChain.setId(null);
                    BeanUtils.copyProperties(cpPo, supplyChain); // 复制属性
                    return supplyChain; // 返回新对象
                })
                .collect(Collectors.toList());
        assetSupplyChainService.saveBatch(SupplyChainNewList);
        //UnitOtherConcatCpPo
        List<UnitOtherConcatCpPo> UnitOtherConcatList = unitOtherConcatCpService.findByTaskId(req.getTaskId());
        List<Long> UnitOtherConcatidList = UnitOtherConcatList.stream()
                .map(UnitOtherConcatCpPo::getAssetId)
                .collect(Collectors.toList());
        //删除原有数据
        if (CollectionUtil.isNotEmpty(UnitOtherConcatidList)) {
            unitOtherConcatService.deleteIdList(UnitOtherConcatidList);
        }
        List<UnitOtherConcat> UnitOtherConcatNewList = UnitOtherConcatList.stream()
                .map(cpPo -> {
                    UnitOtherConcat unitOtherConcat = new UnitOtherConcat();
                    BeanUtils.copyProperties(cpPo, unitOtherConcat); // 复制属性
                    return unitOtherConcat; // 返回新对象
                })
                .collect(Collectors.toList());
        unitOtherConcatService.saveBatch(UnitOtherConcatNewList);
    }

    @Override
    public Page<AssetdwHcResponse> dwHc(Page<AssetdwHcResponse> assetdwHcResponsePage, AssetdwHcRequest req) {

        return assetTaskDao.dwHc(assetdwHcResponsePage, req);
    }
}
